# coding: utf-8
# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20221001


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class Endpoint(object):
    """
    Description of the endpoint.
    """

    #: A constant which can be used with the compute_type property of a Endpoint.
    #: This constant has a value of "CPU"
    COMPUTE_TYPE_CPU = "CPU"

    #: A constant which can be used with the compute_type property of a Endpoint.
    #: This constant has a value of "GPU"
    COMPUTE_TYPE_GPU = "GPU"

    #: A constant which can be used with the lifecycle_state property of a Endpoint.
    #: This constant has a value of "DELETING"
    LIFECYCLE_STATE_DELETING = "DELETING"

    #: A constant which can be used with the lifecycle_state property of a Endpoint.
    #: This constant has a value of "DELETED"
    LIFECYCLE_STATE_DELETED = "DELETED"

    #: A constant which can be used with the lifecycle_state property of a Endpoint.
    #: This constant has a value of "FAILED"
    LIFECYCLE_STATE_FAILED = "FAILED"

    #: A constant which can be used with the lifecycle_state property of a Endpoint.
    #: This constant has a value of "CREATING"
    LIFECYCLE_STATE_CREATING = "CREATING"

    #: A constant which can be used with the lifecycle_state property of a Endpoint.
    #: This constant has a value of "ACTIVE"
    LIFECYCLE_STATE_ACTIVE = "ACTIVE"

    #: A constant which can be used with the lifecycle_state property of a Endpoint.
    #: This constant has a value of "UPDATING"
    LIFECYCLE_STATE_UPDATING = "UPDATING"

    def __init__(self, **kwargs):
        """
        Initializes a new Endpoint object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param id:
            The value to assign to the id property of this Endpoint.
        :type id: str

        :param alias:
            The value to assign to the alias property of this Endpoint.
        :type alias: str

        :param compute_type:
            The value to assign to the compute_type property of this Endpoint.
            Allowed values for this property are: "CPU", "GPU", 'UNKNOWN_ENUM_VALUE'.
            Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.
        :type compute_type: str

        :param display_name:
            The value to assign to the display_name property of this Endpoint.
        :type display_name: str

        :param compartment_id:
            The value to assign to the compartment_id property of this Endpoint.
        :type compartment_id: str

        :param project_id:
            The value to assign to the project_id property of this Endpoint.
        :type project_id: str

        :param description:
            The value to assign to the description property of this Endpoint.
        :type description: str

        :param time_created:
            The value to assign to the time_created property of this Endpoint.
        :type time_created: datetime

        :param time_updated:
            The value to assign to the time_updated property of this Endpoint.
        :type time_updated: datetime

        :param lifecycle_state:
            The value to assign to the lifecycle_state property of this Endpoint.
            Allowed values for this property are: "DELETING", "DELETED", "FAILED", "CREATING", "ACTIVE", "UPDATING", 'UNKNOWN_ENUM_VALUE'.
            Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.
        :type lifecycle_state: str

        :param lifecycle_details:
            The value to assign to the lifecycle_details property of this Endpoint.
        :type lifecycle_details: str

        :param inference_units:
            The value to assign to the inference_units property of this Endpoint.
        :type inference_units: int

        :param model_id:
            The value to assign to the model_id property of this Endpoint.
        :type model_id: str

        :param freeform_tags:
            The value to assign to the freeform_tags property of this Endpoint.
        :type freeform_tags: dict(str, str)

        :param defined_tags:
            The value to assign to the defined_tags property of this Endpoint.
        :type defined_tags: dict(str, dict(str, object))

        :param system_tags:
            The value to assign to the system_tags property of this Endpoint.
        :type system_tags: dict(str, dict(str, object))

        """
        self.swagger_types = {
            'id': 'str',
            'alias': 'str',
            'compute_type': 'str',
            'display_name': 'str',
            'compartment_id': 'str',
            'project_id': 'str',
            'description': 'str',
            'time_created': 'datetime',
            'time_updated': 'datetime',
            'lifecycle_state': 'str',
            'lifecycle_details': 'str',
            'inference_units': 'int',
            'model_id': 'str',
            'freeform_tags': 'dict(str, str)',
            'defined_tags': 'dict(str, dict(str, object))',
            'system_tags': 'dict(str, dict(str, object))'
        }

        self.attribute_map = {
            'id': 'id',
            'alias': 'alias',
            'compute_type': 'computeType',
            'display_name': 'displayName',
            'compartment_id': 'compartmentId',
            'project_id': 'projectId',
            'description': 'description',
            'time_created': 'timeCreated',
            'time_updated': 'timeUpdated',
            'lifecycle_state': 'lifecycleState',
            'lifecycle_details': 'lifecycleDetails',
            'inference_units': 'inferenceUnits',
            'model_id': 'modelId',
            'freeform_tags': 'freeformTags',
            'defined_tags': 'definedTags',
            'system_tags': 'systemTags'
        }

        self._id = None
        self._alias = None
        self._compute_type = None
        self._display_name = None
        self._compartment_id = None
        self._project_id = None
        self._description = None
        self._time_created = None
        self._time_updated = None
        self._lifecycle_state = None
        self._lifecycle_details = None
        self._inference_units = None
        self._model_id = None
        self._freeform_tags = None
        self._defined_tags = None
        self._system_tags = None

    @property
    def id(self):
        """
        **[Required]** Gets the id of this Endpoint.
        Unique identifier endpoint OCID of an endpoint that is immutable on creation.


        :return: The id of this Endpoint.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this Endpoint.
        Unique identifier endpoint OCID of an endpoint that is immutable on creation.


        :param id: The id of this Endpoint.
        :type: str
        """
        self._id = id

    @property
    def alias(self):
        """
        Gets the alias of this Endpoint.
        Unique name across user tenancy in a region to identify an endpoint to be used for inferencing.


        :return: The alias of this Endpoint.
        :rtype: str
        """
        return self._alias

    @alias.setter
    def alias(self, alias):
        """
        Sets the alias of this Endpoint.
        Unique name across user tenancy in a region to identify an endpoint to be used for inferencing.


        :param alias: The alias of this Endpoint.
        :type: str
        """
        self._alias = alias

    @property
    def compute_type(self):
        """
        Gets the compute_type of this Endpoint.
        Compute infra type for endpoint.

        Allowed values for this property are: "CPU", "GPU", 'UNKNOWN_ENUM_VALUE'.
        Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.


        :return: The compute_type of this Endpoint.
        :rtype: str
        """
        return self._compute_type

    @compute_type.setter
    def compute_type(self, compute_type):
        """
        Sets the compute_type of this Endpoint.
        Compute infra type for endpoint.


        :param compute_type: The compute_type of this Endpoint.
        :type: str
        """
        allowed_values = ["CPU", "GPU"]
        if not value_allowed_none_or_none_sentinel(compute_type, allowed_values):
            compute_type = 'UNKNOWN_ENUM_VALUE'
        self._compute_type = compute_type

    @property
    def display_name(self):
        """
        **[Required]** Gets the display_name of this Endpoint.
        A user-friendly display name for the resource. It should be unique and can be modified. Avoid entering confidential information.


        :return: The display_name of this Endpoint.
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """
        Sets the display_name of this Endpoint.
        A user-friendly display name for the resource. It should be unique and can be modified. Avoid entering confidential information.


        :param display_name: The display_name of this Endpoint.
        :type: str
        """
        self._display_name = display_name

    @property
    def compartment_id(self):
        """
        **[Required]** Gets the compartment_id of this Endpoint.
        The `OCID`__ for the endpoint compartment.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :return: The compartment_id of this Endpoint.
        :rtype: str
        """
        return self._compartment_id

    @compartment_id.setter
    def compartment_id(self, compartment_id):
        """
        Sets the compartment_id of this Endpoint.
        The `OCID`__ for the endpoint compartment.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm


        :param compartment_id: The compartment_id of this Endpoint.
        :type: str
        """
        self._compartment_id = compartment_id

    @property
    def project_id(self):
        """
        **[Required]** Gets the project_id of this Endpoint.
        The `OCID`__ of the project to associate with the Endpoint.

        __ https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm


        :return: The project_id of this Endpoint.
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """
        Sets the project_id of this Endpoint.
        The `OCID`__ of the project to associate with the Endpoint.

        __ https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm


        :param project_id: The project_id of this Endpoint.
        :type: str
        """
        self._project_id = project_id

    @property
    def description(self):
        """
        Gets the description of this Endpoint.
        A short description of the endpoint.


        :return: The description of this Endpoint.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this Endpoint.
        A short description of the endpoint.


        :param description: The description of this Endpoint.
        :type: str
        """
        self._description = description

    @property
    def time_created(self):
        """
        **[Required]** Gets the time_created of this Endpoint.
        The time the the endpoint was created. An RFC3339 formatted datetime string.


        :return: The time_created of this Endpoint.
        :rtype: datetime
        """
        return self._time_created

    @time_created.setter
    def time_created(self, time_created):
        """
        Sets the time_created of this Endpoint.
        The time the the endpoint was created. An RFC3339 formatted datetime string.


        :param time_created: The time_created of this Endpoint.
        :type: datetime
        """
        self._time_created = time_created

    @property
    def time_updated(self):
        """
        Gets the time_updated of this Endpoint.
        The time the endpoint was updated. An RFC3339 formatted datetime string.


        :return: The time_updated of this Endpoint.
        :rtype: datetime
        """
        return self._time_updated

    @time_updated.setter
    def time_updated(self, time_updated):
        """
        Sets the time_updated of this Endpoint.
        The time the endpoint was updated. An RFC3339 formatted datetime string.


        :param time_updated: The time_updated of this Endpoint.
        :type: datetime
        """
        self._time_updated = time_updated

    @property
    def lifecycle_state(self):
        """
        **[Required]** Gets the lifecycle_state of this Endpoint.
        The state of the endpoint.

        Allowed values for this property are: "DELETING", "DELETED", "FAILED", "CREATING", "ACTIVE", "UPDATING", 'UNKNOWN_ENUM_VALUE'.
        Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.


        :return: The lifecycle_state of this Endpoint.
        :rtype: str
        """
        return self._lifecycle_state

    @lifecycle_state.setter
    def lifecycle_state(self, lifecycle_state):
        """
        Sets the lifecycle_state of this Endpoint.
        The state of the endpoint.


        :param lifecycle_state: The lifecycle_state of this Endpoint.
        :type: str
        """
        allowed_values = ["DELETING", "DELETED", "FAILED", "CREATING", "ACTIVE", "UPDATING"]
        if not value_allowed_none_or_none_sentinel(lifecycle_state, allowed_values):
            lifecycle_state = 'UNKNOWN_ENUM_VALUE'
        self._lifecycle_state = lifecycle_state

    @property
    def lifecycle_details(self):
        """
        Gets the lifecycle_details of this Endpoint.
        A message describing the current state in more detail. For example, can be used to provide actionable information for a resource in failed state.


        :return: The lifecycle_details of this Endpoint.
        :rtype: str
        """
        return self._lifecycle_details

    @lifecycle_details.setter
    def lifecycle_details(self, lifecycle_details):
        """
        Sets the lifecycle_details of this Endpoint.
        A message describing the current state in more detail. For example, can be used to provide actionable information for a resource in failed state.


        :param lifecycle_details: The lifecycle_details of this Endpoint.
        :type: str
        """
        self._lifecycle_details = lifecycle_details

    @property
    def inference_units(self):
        """
        Gets the inference_units of this Endpoint.
        Number of replicas required for this endpoint.


        :return: The inference_units of this Endpoint.
        :rtype: int
        """
        return self._inference_units

    @inference_units.setter
    def inference_units(self, inference_units):
        """
        Sets the inference_units of this Endpoint.
        Number of replicas required for this endpoint.


        :param inference_units: The inference_units of this Endpoint.
        :type: int
        """
        self._inference_units = inference_units

    @property
    def model_id(self):
        """
        **[Required]** Gets the model_id of this Endpoint.
        The `OCID`__ of the model to associate with the endpoint.

        __ https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm


        :return: The model_id of this Endpoint.
        :rtype: str
        """
        return self._model_id

    @model_id.setter
    def model_id(self, model_id):
        """
        Sets the model_id of this Endpoint.
        The `OCID`__ of the model to associate with the endpoint.

        __ https://docs.cloud.oracle.com/iaas/Content/General/Concepts/identifiers.htm


        :param model_id: The model_id of this Endpoint.
        :type: str
        """
        self._model_id = model_id

    @property
    def freeform_tags(self):
        """
        Gets the freeform_tags of this Endpoint.
        Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`


        :return: The freeform_tags of this Endpoint.
        :rtype: dict(str, str)
        """
        return self._freeform_tags

    @freeform_tags.setter
    def freeform_tags(self, freeform_tags):
        """
        Sets the freeform_tags of this Endpoint.
        Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`


        :param freeform_tags: The freeform_tags of this Endpoint.
        :type: dict(str, str)
        """
        self._freeform_tags = freeform_tags

    @property
    def defined_tags(self):
        """
        Gets the defined_tags of this Endpoint.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`


        :return: The defined_tags of this Endpoint.
        :rtype: dict(str, dict(str, object))
        """
        return self._defined_tags

    @defined_tags.setter
    def defined_tags(self, defined_tags):
        """
        Sets the defined_tags of this Endpoint.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`


        :param defined_tags: The defined_tags of this Endpoint.
        :type: dict(str, dict(str, object))
        """
        self._defined_tags = defined_tags

    @property
    def system_tags(self):
        """
        Gets the system_tags of this Endpoint.
        Usage of system tag keys. These predefined keys are scoped to namespaces.
        Example: `{ \"orcl-cloud\": { \"free-tier-retained\": \"true\" } }`


        :return: The system_tags of this Endpoint.
        :rtype: dict(str, dict(str, object))
        """
        return self._system_tags

    @system_tags.setter
    def system_tags(self, system_tags):
        """
        Sets the system_tags of this Endpoint.
        Usage of system tag keys. These predefined keys are scoped to namespaces.
        Example: `{ \"orcl-cloud\": { \"free-tier-retained\": \"true\" } }`


        :param system_tags: The system_tags of this Endpoint.
        :type: dict(str, dict(str, object))
        """
        self._system_tags = system_tags

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
