# coding: utf-8
# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20160918


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class ReorderExecutionActionDetails(object):
    """
    Describes the ordering list of execution actions for the execution window.
    """

    def __init__(self, **kwargs):
        """
        Initializes a new ReorderExecutionActionDetails object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param execution_action_order_list:
            The value to assign to the execution_action_order_list property of this ReorderExecutionActionDetails.
        :type execution_action_order_list: list[oci.database.models.ActionOrderDetails]

        :param freeform_tags:
            The value to assign to the freeform_tags property of this ReorderExecutionActionDetails.
        :type freeform_tags: dict(str, str)

        :param defined_tags:
            The value to assign to the defined_tags property of this ReorderExecutionActionDetails.
        :type defined_tags: dict(str, dict(str, object))

        """
        self.swagger_types = {
            'execution_action_order_list': 'list[ActionOrderDetails]',
            'freeform_tags': 'dict(str, str)',
            'defined_tags': 'dict(str, dict(str, object))'
        }

        self.attribute_map = {
            'execution_action_order_list': 'executionActionOrderList',
            'freeform_tags': 'freeformTags',
            'defined_tags': 'definedTags'
        }

        self._execution_action_order_list = None
        self._freeform_tags = None
        self._defined_tags = None

    @property
    def execution_action_order_list(self):
        """
        Gets the execution_action_order_list of this ReorderExecutionActionDetails.
        List of action resources in a specific order.
        Example: [{actionOrder: 1, actionResourceId: \"resourceId1\"}, {actionOrder: 2, actionResourceId: \"resourceId2\"}]


        :return: The execution_action_order_list of this ReorderExecutionActionDetails.
        :rtype: list[oci.database.models.ActionOrderDetails]
        """
        return self._execution_action_order_list

    @execution_action_order_list.setter
    def execution_action_order_list(self, execution_action_order_list):
        """
        Sets the execution_action_order_list of this ReorderExecutionActionDetails.
        List of action resources in a specific order.
        Example: [{actionOrder: 1, actionResourceId: \"resourceId1\"}, {actionOrder: 2, actionResourceId: \"resourceId2\"}]


        :param execution_action_order_list: The execution_action_order_list of this ReorderExecutionActionDetails.
        :type: list[oci.database.models.ActionOrderDetails]
        """
        self._execution_action_order_list = execution_action_order_list

    @property
    def freeform_tags(self):
        """
        Gets the freeform_tags of this ReorderExecutionActionDetails.
        Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace.
        For more information, see `Resource Tags`__.

        Example: `{\"Department\": \"Finance\"}`

        __ https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm


        :return: The freeform_tags of this ReorderExecutionActionDetails.
        :rtype: dict(str, str)
        """
        return self._freeform_tags

    @freeform_tags.setter
    def freeform_tags(self, freeform_tags):
        """
        Sets the freeform_tags of this ReorderExecutionActionDetails.
        Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace.
        For more information, see `Resource Tags`__.

        Example: `{\"Department\": \"Finance\"}`

        __ https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm


        :param freeform_tags: The freeform_tags of this ReorderExecutionActionDetails.
        :type: dict(str, str)
        """
        self._freeform_tags = freeform_tags

    @property
    def defined_tags(self):
        """
        Gets the defined_tags of this ReorderExecutionActionDetails.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        For more information, see `Resource Tags`__.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm


        :return: The defined_tags of this ReorderExecutionActionDetails.
        :rtype: dict(str, dict(str, object))
        """
        return self._defined_tags

    @defined_tags.setter
    def defined_tags(self, defined_tags):
        """
        Sets the defined_tags of this ReorderExecutionActionDetails.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        For more information, see `Resource Tags`__.

        __ https://docs.cloud.oracle.com/Content/General/Concepts/resourcetags.htm


        :param defined_tags: The defined_tags of this ReorderExecutionActionDetails.
        :type: dict(str, dict(str, object))
        """
        self._defined_tags = defined_tags

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
