# coding: utf-8
# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20230801

from __future__ import absolute_import

from .approve_delegated_resource_access_request_details import ApproveDelegatedResourceAccessRequestDetails
from .change_delegation_control_compartment_details import ChangeDelegationControlCompartmentDetails
from .change_delegation_subscription_compartment_details import ChangeDelegationSubscriptionCompartmentDetails
from .create_delegation_control_details import CreateDelegationControlDetails
from .create_delegation_subscription_details import CreateDelegationSubscriptionDetails
from .delegated_resource_access_request import DelegatedResourceAccessRequest
from .delegated_resource_access_request_approval_details import DelegatedResourceAccessRequestApprovalDetails
from .delegated_resource_access_request_audit_log_report import DelegatedResourceAccessRequestAuditLogReport
from .delegated_resource_access_request_history_collection import DelegatedResourceAccessRequestHistoryCollection
from .delegated_resource_access_request_history_summary import DelegatedResourceAccessRequestHistorySummary
from .delegated_resource_access_request_summary import DelegatedResourceAccessRequestSummary
from .delegated_resource_access_request_summary_collection import DelegatedResourceAccessRequestSummaryCollection
from .delegation_control import DelegationControl
from .delegation_control_resource_collection import DelegationControlResourceCollection
from .delegation_control_resource_summary import DelegationControlResourceSummary
from .delegation_control_summary import DelegationControlSummary
from .delegation_control_summary_collection import DelegationControlSummaryCollection
from .delegation_subscription import DelegationSubscription
from .delegation_subscription_summary import DelegationSubscriptionSummary
from .delegation_subscription_summary_collection import DelegationSubscriptionSummaryCollection
from .reject_delegated_resource_access_request_details import RejectDelegatedResourceAccessRequestDetails
from .revoke_delegated_resource_access_request_details import RevokeDelegatedResourceAccessRequestDetails
from .service_provider import ServiceProvider
from .service_provider_action import ServiceProviderAction
from .service_provider_action_properties import ServiceProviderActionProperties
from .service_provider_action_summary import ServiceProviderActionSummary
from .service_provider_action_summary_collection import ServiceProviderActionSummaryCollection
from .service_provider_interaction_collection import ServiceProviderInteractionCollection
from .service_provider_interaction_request_details import ServiceProviderInteractionRequestDetails
from .service_provider_interaction_summary import ServiceProviderInteractionSummary
from .service_provider_summary import ServiceProviderSummary
from .service_provider_summary_collection import ServiceProviderSummaryCollection
from .update_delegation_control_details import UpdateDelegationControlDetails
from .update_delegation_subscription_details import UpdateDelegationSubscriptionDetails
from .work_request import WorkRequest
from .work_request_error import WorkRequestError
from .work_request_error_collection import WorkRequestErrorCollection
from .work_request_log_entry import WorkRequestLogEntry
from .work_request_log_entry_collection import WorkRequestLogEntryCollection
from .work_request_resource import WorkRequestResource
from .work_request_summary import WorkRequestSummary
from .work_request_summary_collection import WorkRequestSummaryCollection

# Maps type names to classes for delegate_access_control services.
delegate_access_control_type_mapping = {
    "ApproveDelegatedResourceAccessRequestDetails": ApproveDelegatedResourceAccessRequestDetails,
    "ChangeDelegationControlCompartmentDetails": ChangeDelegationControlCompartmentDetails,
    "ChangeDelegationSubscriptionCompartmentDetails": ChangeDelegationSubscriptionCompartmentDetails,
    "CreateDelegationControlDetails": CreateDelegationControlDetails,
    "CreateDelegationSubscriptionDetails": CreateDelegationSubscriptionDetails,
    "DelegatedResourceAccessRequest": DelegatedResourceAccessRequest,
    "DelegatedResourceAccessRequestApprovalDetails": DelegatedResourceAccessRequestApprovalDetails,
    "DelegatedResourceAccessRequestAuditLogReport": DelegatedResourceAccessRequestAuditLogReport,
    "DelegatedResourceAccessRequestHistoryCollection": DelegatedResourceAccessRequestHistoryCollection,
    "DelegatedResourceAccessRequestHistorySummary": DelegatedResourceAccessRequestHistorySummary,
    "DelegatedResourceAccessRequestSummary": DelegatedResourceAccessRequestSummary,
    "DelegatedResourceAccessRequestSummaryCollection": DelegatedResourceAccessRequestSummaryCollection,
    "DelegationControl": DelegationControl,
    "DelegationControlResourceCollection": DelegationControlResourceCollection,
    "DelegationControlResourceSummary": DelegationControlResourceSummary,
    "DelegationControlSummary": DelegationControlSummary,
    "DelegationControlSummaryCollection": DelegationControlSummaryCollection,
    "DelegationSubscription": DelegationSubscription,
    "DelegationSubscriptionSummary": DelegationSubscriptionSummary,
    "DelegationSubscriptionSummaryCollection": DelegationSubscriptionSummaryCollection,
    "RejectDelegatedResourceAccessRequestDetails": RejectDelegatedResourceAccessRequestDetails,
    "RevokeDelegatedResourceAccessRequestDetails": RevokeDelegatedResourceAccessRequestDetails,
    "ServiceProvider": ServiceProvider,
    "ServiceProviderAction": ServiceProviderAction,
    "ServiceProviderActionProperties": ServiceProviderActionProperties,
    "ServiceProviderActionSummary": ServiceProviderActionSummary,
    "ServiceProviderActionSummaryCollection": ServiceProviderActionSummaryCollection,
    "ServiceProviderInteractionCollection": ServiceProviderInteractionCollection,
    "ServiceProviderInteractionRequestDetails": ServiceProviderInteractionRequestDetails,
    "ServiceProviderInteractionSummary": ServiceProviderInteractionSummary,
    "ServiceProviderSummary": ServiceProviderSummary,
    "ServiceProviderSummaryCollection": ServiceProviderSummaryCollection,
    "UpdateDelegationControlDetails": UpdateDelegationControlDetails,
    "UpdateDelegationSubscriptionDetails": UpdateDelegationSubscriptionDetails,
    "WorkRequest": WorkRequest,
    "WorkRequestError": WorkRequestError,
    "WorkRequestErrorCollection": WorkRequestErrorCollection,
    "WorkRequestLogEntry": WorkRequestLogEntry,
    "WorkRequestLogEntryCollection": WorkRequestLogEntryCollection,
    "WorkRequestResource": WorkRequestResource,
    "WorkRequestSummary": WorkRequestSummary,
    "WorkRequestSummaryCollection": WorkRequestSummaryCollection
}
