# coding: utf-8
# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: v1


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class OciConsoleSignOnPolicyConsentPolicyResource(object):
    """
    Policy Resource

    **SCIM++ Properties:**
    - idcsSearchable: true
    - multiValued: false
    - mutability: immutable
    - required: true
    - returned: default
    - type: complex
    - uniqueness: none
    """

    def __init__(self, **kwargs):
        """
        Initializes a new OciConsoleSignOnPolicyConsentPolicyResource object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param value:
            The value to assign to the value property of this OciConsoleSignOnPolicyConsentPolicyResource.
        :type value: str

        :param ocid:
            The value to assign to the ocid property of this OciConsoleSignOnPolicyConsentPolicyResource.
        :type ocid: str

        """
        self.swagger_types = {
            'value': 'str',
            'ocid': 'str'
        }

        self.attribute_map = {
            'value': 'value',
            'ocid': 'ocid'
        }

        self._value = None
        self._ocid = None

    @property
    def value(self):
        """
        **[Required]** Gets the value of this OciConsoleSignOnPolicyConsentPolicyResource.
        Policy Resource Id

        **SCIM++ Properties:**
         - caseExact: true
         - idcsSearchable: true
         - multiValued: false
         - mutability: immutable
         - required: true
         - returned: default
         - type: string


        :return: The value of this OciConsoleSignOnPolicyConsentPolicyResource.
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Sets the value of this OciConsoleSignOnPolicyConsentPolicyResource.
        Policy Resource Id

        **SCIM++ Properties:**
         - caseExact: true
         - idcsSearchable: true
         - multiValued: false
         - mutability: immutable
         - required: true
         - returned: default
         - type: string


        :param value: The value of this OciConsoleSignOnPolicyConsentPolicyResource.
        :type: str
        """
        self._value = value

    @property
    def ocid(self):
        """
        **[Required]** Gets the ocid of this OciConsoleSignOnPolicyConsentPolicyResource.
        Policy Resource Ocid

        **SCIM++ Properties:**
         - caseExact: true
         - idcsSearchable: true
         - multiValued: false
         - mutability: immutable
         - required: true
         - returned: default
         - type: string


        :return: The ocid of this OciConsoleSignOnPolicyConsentPolicyResource.
        :rtype: str
        """
        return self._ocid

    @ocid.setter
    def ocid(self, ocid):
        """
        Sets the ocid of this OciConsoleSignOnPolicyConsentPolicyResource.
        Policy Resource Ocid

        **SCIM++ Properties:**
         - caseExact: true
         - idcsSearchable: true
         - multiValued: false
         - mutability: immutable
         - required: true
         - returned: default
         - type: string


        :param ocid: The ocid of this OciConsoleSignOnPolicyConsentPolicyResource.
        :type: str
        """
        self._ocid = ocid

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
